# $Id: xchain-gccstage2.make,v 0.3.2.1 2002/09/15 22:15:00 robert Exp $
#
# (c) 2002 by Pengutronix e.K., Hildesheim, Germany
# See CREDITS for details about who has contributed to this project. 
#
# For further information about the PTXDIST project and license conditions
# see the README file.
#

#
# We provide this package
#
ifeq (y,$(PTXCONF_BUILD_CROSSCHAIN))
PACKAGES += xchain-gccstage2
endif

#
# Paths and names 
#
# See gccstage1 for variable definitions


# ----------------------------------------------------------------------------
# Get
# ----------------------------------------------------------------------------

xchain-gccstage2_get: $(STATEDIR)/glibc.install

$(STATEDIR)/xchain-gccstage2.get: $(STATEDIR)/xchain-gccstage1.get
	touch $@

# ----------------------------------------------------------------------------
# Extract
# ----------------------------------------------------------------------------

xchain-gccstage2_extract: $(STATEDIR)/xchain-gccstage2.extract

$(STATEDIR)/xchain-gccstage2.extract: 					\
	$(STATEDIR)/xchain-gccstage2.get				\
	$(STATEDIR)/glibc.install
	@echo
	@echo ------------------------
	@echo xchain-gccstage2.extract 
	@echo ------------------------
	@echo
	# remove glibc header hack
	perl -p -i -e 									\
		's/^(TARGET_LIBGCC2_CFLAGS = -fomit-frame-pointer -fPIC).*/$$1/' 	\
		$(GCC_DIR)/gcc/config/arm/t-linux
	touch $@

# ----------------------------------------------------------------------------
# Prepare
# ----------------------------------------------------------------------------

xchain-gccstage2_prepare: $(STATEDIR)/xchain-gccstage2.prepare

$(STATEDIR)/xchain-gccstage2.prepare: $(STATEDIR)/xchain-gccstage2.extract
	@echo
	@echo ------------------------
	@echo xchain-gccstage2.prepare 
	@echo ------------------------
	@echo
	[ -d $(GCC_STAGE2_DIR) ] || mkdir $(GCC_STAGE2_DIR)
	cd $(GCC_STAGE2_DIR) && 						\
		PATH=$(PTXCONF_CROSSCHAIN_PREFIX)/bin:$$PATH			\
	  	AR=arm-linux-ar							\
		RANLIB=arm-linux-ranlib						\
	     	CC=$(HOSTCC)							\
		$(GCC_DIR)/configure 						\
			--target=arm-linux					\
			--prefix=$(PTXCONF_CROSSCHAIN_PREFIX)			\
			--enable-target-optspace				\
			--disable-nls						\
			--with-gnu-ld						\
			--disable-shared					\
			--enable-languages="c"					\
			--with-headers=$(KERNEL_DIR)/include			\
			--with-headers=$(PTXCONF_CROSSCHAIN_PREFIX)/include	\
			--with-libs=$(PTXCONF_CROSSCHAIN_PREFIX)/lib
	touch $@

# ----------------------------------------------------------------------------
# Compile
# ----------------------------------------------------------------------------

xchain-gccstage2_compile: $(STATEDIR)/xchain-gccstage2.compile

$(STATEDIR)/xchain-gccstage2.compile: 					\
	$(STATEDIR)/xchain-gccstage2.prepare
	@echo
	@echo ------------------------
	@echo xchain-gccstage2.compile 
	@echo ------------------------
	@echo
	PATH=$(PATH):$(PTXCONF_CROSSCHAIN_PREFIX)/bin 			\
		make -C $(GCC_STAGE2_DIR) TOOL_INCLUDE_DIR=$(PTXCONF_CROSSCHAIN_PREFIX)/include
	touch $@

# ----------------------------------------------------------------------------
# Install
# ----------------------------------------------------------------------------

xchain-gccstage2_install: $(STATEDIR)/xchain-gccstage2.install

$(STATEDIR)/xchain-gccstage2.install: $(STATEDIR)/xchain-gccstage2.compile
	@echo
	@echo ------------------------
	@echo xchain-gccstage2.install 
	@echo ------------------------
	@echo
	PATH=$(PATH):$(PTXCONF_CROSSCHAIN_PREFIX)/bin make -C $(GCC_STAGE2_DIR) install
	touch $@

# ----------------------------------------------------------------------------
# Clean
# ----------------------------------------------------------------------------

xchain-gccstage2_clean:
	rm -fr $(GCC_STAGE2_DIR) $(STATEDIR)/xchain-gccstage2.* 


# vim: syntax=make
